﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.InteropServices;


namespace Draw_A_Line_UnitTestProject
{
    /// <summary>
    /// 在Windows窗口上画图形
    /// </summary>
    class Draw_A_Line : System.Windows.Forms.Form
    {
        //private Form MainForm;
        System.ComponentModel.Container component = null;
        Pen myPen = new Pen(Color.Black);
        Bitmap bmpImg = null;

        public Draw_A_Line()
        {
            InitializeComponent();
        }

        private void InitializeComponent()
        {
            this.component = new System.ComponentModel.Container();
            this.Size = new Size(256, 256);
            this.Text = "TestMainForm";

        }

        /// <summary>
        /// 清理正在使用的资源
        /// </summary>
        /// <param name="disposing"></param>
        protected override void Dispose(bool disposing)
        {
            saveBmp();
            if (disposing)
            {
                if (component != null)
                {
                    saveBmp(); //保存截图
                    component.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        //static Graphics SaveGraph;
        protected override void OnPaint(PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            myPen.Width = 5;
            g.DrawLine(myPen, 16, 27, 38, 49);
        }

        [DllImport("gdi32.dll", CharSet = CharSet.Auto, SetLastError = true, ExactSpelling = true)]
        public static extern int BitBlt(HandleRef hDC, int x, int y, int nWidth, int nHeight, HandleRef hSrcDC, int xSrc, int ySrc, int dwRop);


        public void saveBmp()
        {
            //这里假设要保存一个窗体的内容

            int width = 200;     //获取宽度

            int height = 200;     //获取高度

            const int SRCCOPY = 0xcc0020;     //复制图块的光栅操作码

            Bitmap bmSave = new Bitmap(width, height);     //用于保存图片的位图对象

            Graphics gSave = Graphics.FromImage(bmSave);     //创建该位图的Graphics对象

            HandleRef hDcSave = new HandleRef(null, gSave.GetHdc());     //得到句柄

            Graphics gSrc = this.CreateGraphics();     //创建窗体的Graphics对象

            HandleRef hDcSrc = new HandleRef(null, gSrc.GetHdc());

            BitBlt(hDcSave, 0, 0, width, height, hDcSrc, 0, 0, SRCCOPY);

            gSrc.ReleaseHdc();

            gSave.ReleaseHdc();

            bmSave.Save(@"C:\test.jpg",System.Drawing.Imaging.ImageFormat.Jpeg);

            gSrc.Dispose();

            gSave.Dispose();

            bmSave.Dispose();

        }

        public void DrawRecentage()
        {

        }
    }
}
